import time
import asyncio
from telethon import TelegramClient, events
from telethon.errors.rpcerrorlist import AuthKeyError
from telethon.sync import TelegramClient as SyncTelegramClient
import json
import datetime
import signal
import sys
import math
from telethon.tl.types import MessageEntityTextUrl
from apscheduler.schedulers.background import BackgroundScheduler
from telethon.tl.types import PeerUser, PeerChat, PeerChannel
import os
import traceback
import re
from apscheduler.schedulers.asyncio import AsyncIOScheduler
from code.ignore_config import obj_dalaobuytokenscounts
from code.ignore_config import obj_dalaoAdd_onlysell
from code.ignore_config import obj_mine_gendan_profit_info
from code.ignore_config import arr_dalao_allowpump
from code.ignore_config import  mywalletaddress
old_print = print


def timestamped_print(*args, **kwargs):
    old_print(datetime.datetime.utcnow().replace(
        microsecond=0), *args, **kwargs)


print = timestamped_print
print('\n'*5)

def global_exception_hook(exc_type, exc_value, exc_traceback):
    print(f"Global exception: {exc_type.__name__} - {exc_value}")
    traceback.print_tb(exc_traceback)
    raise

def keep_alnum_forgmgn(string):
    return re.sub(r'[^a-zA-Z0-9\.\s\+\-]', ' ', string)


def keep_alnum(string):
    return re.sub(r'[^a-zA-Z0-9\.\s:+-]', ' ', string)
 
def term_sig_handler(signum, frame):   
    # save_obj_unraydium_token()
    print(f'catched singal: {signum}')
    
    sys.exit()




def global_exception_hook(exc_type, exc_value, exc_traceback):
    print(f"Global exception: {exc_type.__name__} - {exc_value}")
    traceback.print_tb(exc_traceback)
    raise



api_id_gate = 29760088
api_hash_gate = "7cd2222e0629c770789f9c6cf280d051"

# ID: 6541198030,  Name: Fluxbot
api_id_bill = 26338039
api_hash_bill = "09bcd8c34c696df21466303aa13c8913"

Fluxbot_id = 6541198030
GMGN_bot_id = 6344329830
 
arr_Sol_Trading_Bot_id = [  GMGN_bot_id  ]
now_chat_id = arr_Sol_Trading_Bot_id[0]
now_chat_id_idx = 0
lastest_message_id = -1
client_gate = TelegramClient('anon_gate', api_id_gate, api_hash_gate)
client_gate.start()


 
# arr_dalaotimestamp = list(tempobj_mine_ready_swap_action.keys())

# for str_dalaotimestamp in arr_dalaotimestamp:
#     obj_mine_ready_swap_action[int(str_dalaotimestamp)] = tempobj_mine_ready_swap_action[str_dalaotimestamp]
 
 
obj_ready_get_token_info={}

obj_token_info={
        # "token_address":{
        #         "is_normal":"false",
        #         "now_price":"",
        #         "buy_time":"",
                # "now_price" =     None
                # "last_5m_change" = None
                # "last_1h_change" = None
                # "number_open" =   0
                # "number_liq" =    0
                # "nomint_flag" = None
                # "blacklist_flag" = None
                # "burnt_flag" = None
                # "number_insiders" =   None
                # "number_top_10_holding" = None

        #         "arr_dalao_addrees":[],
        #         "dalao_swap_info":{
        #                 "dalao_address":{
        #                         "buy_time":"",
        #                         "token_amount":"",
        #                         "sol_amount":"",
        #                 }
                        
        #         }
        # }

}

obj_last_3h_token_info={
    # "token_address":{
    #         "dalao_address":{
    #                 "buy_time":"ddd",
    #         }
    #         }

}

async def  send_token_address_message(chat_id , str_swap_token_address):  
    print(f"enter send_token_address_message str_swap_token_address={str_swap_token_address}")      
    
    # await client_gate.send_message(Sol_Trading_Bot_Europe_id, str_swap_token_address)
    await client_gate.send_message(chat_id, str_swap_token_address)
    return
# flux 获取dlao swap info 保存进 obj_mine_ready_swap_action 
# 在一个定时器 的函数中 便利读取 obj_mine_ready_swap_action ，对每一个元素进行check 如果可以买卖则进行买卖
 

def send_token_info_to_feishu(token_info):
    print("send_token_info_to_feishu token_info=",token_info)
    return
 




@client_gate.on(events.NewMessage(chats=[Fluxbot_id], incoming=True))
async def handle_incoming_gate_Fluxbot(event):
    global   obj_dalaoAdd_onlysell

    event_message = event.message
    message_text = event.message.message
   
    # print(
    #     f"gate handle_incoming_gate_Fluxbot NewMessage event_message=", event_message)
    # await asyncio.sleep(1)


    if "new copy trade" not in message_text.lower():
        return
    dalao_txhash = None
    entities_MessageEntityTextUrl = event_message.get_entities_text(MessageEntityTextUrl)
    # print("entities_MessageEntityTextUrl=",entities_MessageEntityTextUrl,type(entities_MessageEntityTextUrl))
    if not entities_MessageEntityTextUrl:
        return
    for url_entity, inner_text in entities_MessageEntityTextUrl:

        url = url_entity.url
        if "https://solscan.io/tx/" in url:
            dalao_txhash = url.split('/')[-1]
        print(f"gate handle_incoming_gate_Fluxbot NewMessage dalao_txhash={dalao_txhash}")
        break
     

    message_text = keep_alnum(string=message_text.strip())
    message_text=message_text.strip()
    message_text=re.sub(r'\s+', ' ', message_text)
 

    Token_B =  message_text.split('Token B:')[-1].strip()
    message_text=message_text.split('Token B:')[0].strip()
    Token_A =  message_text.split('Token A:')[-1].strip()
    message_text=message_text.split('Token A:')[0].strip()
    # print(f"gate handle_incoming_gate_Fluxbot Token_B={Token_B} Token_A={Token_A}")
    # print(f"gate handle_incoming_gate_Fluxbot message_text=",message_text)
    swap_type = ""
    if Token_A=="So11111111111111111111111111111111111111112" or Token_A=="EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v":
        str_swap_token_address = Token_B 
        swap_type = "buy"
    else :
        str_swap_token_address = Token_A
        swap_type = "sell"

    Trader =  message_text.split('Trader:')[-1].strip()
    if obj_dalaobuytokenscounts.get(Trader) is None:
        # 并未跟踪此大佬
        return  
    message_text=message_text.split('Trader:')[0].strip()
    # 获取 TOKEN / MAIN TOKEN Amount
    message_text=message_text.split('Value:')[0].strip()
    str_token_amount = message_text.split('Amount:')[-1].strip()
    arr_token_amount =str_token_amount.split(" ")
    number_token_amount = float(arr_token_amount[0].strip())
    number_token_percent = float(arr_token_amount[-1].strip())
    if swap_type=="buy" and number_token_amount<=0.3:
        # buy token 花费的sol 太少 pass
        return
    

    if obj_dalaoAdd_onlysell.get(Trader) and swap_type=="buy" :
        print(f"str_dalao_address={Trader} not_obj_dalao_swap_info_onlysell")
        return  

    print(f"gate handle_incoming_gate_Fluxbot Trader={Trader} str_swap_token_address={str_swap_token_address}")
    dalao_timestamp = int(time.time()*1000)
    obj_dalao_swap_info ={

        "dalao_timestamp":dalao_timestamp,
        "swap_type":swap_type,
        "is_getting_token":False,
        "need_remove":False,
        "str_swap_token_address":str_swap_token_address,
        "str_dalao_address": Trader,
        "number_dalao_sell_token_percent": number_token_percent ,
        "number_dalao_swap_token_amount":number_token_amount,
        "dalao_txhash":""


    }
    print("gate handle_incoming_gate_Fluxbot obj_dalao_swap_info=",obj_dalao_swap_info)
   
    obj_ready_get_token_info[dalao_timestamp] =obj_dalao_swap_info
    # handle_dalao_swap()

 
 
async def handle_dalao_swap():
        if len(list(obj_ready_get_token_info.keys()))==0:
             return
                
        dalao_timestamp = min(list(obj_ready_get_token_info.keys()))
        obj_dalao_swap_info = obj_ready_get_token_info[dalao_timestamp]
        str_swap_token_address=  obj_dalao_swap_info["str_swap_token_address"]
        str_dalao_address = obj_dalao_swap_info["str_dalao_address"]
        now_timestamp = int(time.time()*1000)
        if now_timestamp - dalao_timestamp >= 3*60 * 1000 :
            # 1.5分钟也没有处理好这个token 说明有问题 pass
            print(f"str_dalao_address={str_dalao_address} str_swap_token_address={str_swap_token_address} cost_time_too_long")
            del obj_ready_get_token_info[dalao_timestamp]
            return
        
        if obj_dalao_swap_info["is_getting_token"]==True:
            return

        obj_dalao_swap_info["is_getting_token"]=True   
        print(f"enter handle_dalao_swap str_dalao_address={str_dalao_address} str_swap_token_address={str_swap_token_address}")
        
     
        # dalao_timestamp=obj_dalao_swap_info["dalao_timestamp"]
        swap_type=obj_dalao_swap_info["swap_type"]
        is_getting_token=obj_dalao_swap_info["is_getting_token"]
        need_remove=obj_dalao_swap_info["need_remove"]
        # str_swap_token_address=obj_dalao_swap_info["str_swap_token_address"]
        # str_dalao_address=obj_dalao_swap_info["str_dalao_address"]
        number_dalao_sell_token_percent=obj_dalao_swap_info["number_dalao_sell_token_percent"]
        number_dalao_swap_token_amount=obj_dalao_swap_info["number_dalao_swap_token_amount"]
  
        if swap_type == "sell":
                if number_dalao_sell_token_percent >0.8 :
                        # dalao 已卖完此token
                        if  obj_token_info.get(str_swap_token_address) is None or str_dalao_address not in obj_token_info.get(str_swap_token_address)["arr_dalao_addrees"] :
                                print("dont has the buytoken info for dalao")
                                obj_dalao_swap_info["need_remove"] = True
                                del obj_ready_get_token_info[dalao_timestamp]
                                return
                                 
                        # 删除 arr_dalao_addrees 中的 dalao
                        obj_token_info.get(str_swap_token_address)["arr_dalao_addrees"].remove(str_dalao_address)
                        obj_token_info.get(str_swap_token_address)["dalao_swap_info"].get(str_dalao_address)["sol_amount"] = 0
                        obj_token_info.get(str_swap_token_address)["dalao_swap_info"].get(str_dalao_address)["token_amount"] = 0
                        
                        
        elif swap_type == "buy":
                
                if ( obj_token_info.get(str_swap_token_address) is not None 
                     and  obj_token_info.get(str_swap_token_address)["dalao_swap_info"].get(str_dalao_address) is not None 
                     and obj_token_info.get(str_swap_token_address)["dalao_swap_info"][str_dalao_address]["sol_amount"] >0   
                     and  dalao_timestamp - obj_token_info.get(str_swap_token_address)["dalao_swap_info"][str_dalao_address]["buy_time"] <= 5 * 60 * 1000 ) :
                    # 最近5分钟买过了 并且没有卖 pass 
                    obj_dalao_swap_info["need_remove"] = True
                    del obj_ready_get_token_info[dalao_timestamp]
                    return
                if obj_token_info.get(str_swap_token_address) is None:
                        obj_token_info[str_swap_token_address]={
                                        "is_normal":False,
                                        "now_price":"",
                                        "buy_time":0,
                                        "arr_dalao_addrees":[   ],
                                        "dalao_swap_info":{   
                                        }
                        }

                if str_dalao_address not in obj_token_info.get(str_swap_token_address)["arr_dalao_addrees"] :
                        obj_token_info.get(str_swap_token_address)["arr_dalao_addrees"].append(str_dalao_address)
                        dalao_swap_info =  obj_token_info.get(str_swap_token_address)["dalao_swap_info"] 
        
                        dalao_swap_info[str_dalao_address] ={
                                        "buy_time":0,
                                        "sol_amount":0,
                        }
                obj_token_info[str_swap_token_address]["buy_time"] = dalao_timestamp   
                obj_token_info[str_swap_token_address]["sol_amount"] = number_dalao_swap_token_amount 

        print(f"ready send_token str_swap_token_address={str_swap_token_address}",obj_token_info[str_swap_token_address])
        await send_token_address_message(chat_id=GMGN_bot_id,str_swap_token_address=str_swap_token_address)
        


 
@client_gate.on(events.NewMessage(chats=[GMGN_bot_id ], incoming=True))
async def handle_incoming_GMGN_bot_NewMessage(event):
    # 【Solana】MAD (MAD)

    # $0.0{4}16505   🔴 -2.26%  Price Chart (https://gmgn.ai/sol/token/madHpjRn6bd8t78Rsy7NuSuNwWa2HU8ByPobZprHbHv?utm_source=telegram&utm_campaign=tg_cmdbot_hot) | Snipe with Bot (https://t.me/GMGN_sol_bot?start=madHpjRn6bd8t78Rsy7NuSuNwWa2HU8ByPobZprHbHv)
    # 📈 5m | 1h | 6h: -0.25% | 0.76% | -3.7%
    # 💰 MC: $16.5M
    # 💧 Liq: 1,862.71 SOL ($512K 🔥99.98%)
    # 💰 Initial LP: 15 SOL (100% supply)
    # 👥 Holders: 12326
    # 👨‍🍳 Creator:  CNBx....FmP (https://solscan.io/account/CNBxpRqrzZZenHU4jT9XXpcxPChtDafTnnrUfSyYFmP8) (2.0708 SOL)
    # 🔥 DEV Burnt: --
    # 🕒 Open: 43d  ago
    # 🔥 Smart Buy/Sell: -/-
    # 🦅 DEXScreener: Advertised ❌ / Update Social ❌

    # 🔔 Audit: NoMint ✅ / Blacklist ✅ / Burnt ✅
    # 👥 Top 10 holdings: 6.92%<30% ✅
    # 1.65 (https://gmgn.ai/sol/address/ASTyfSima4LLAdDgoFGkgqoKowG1LZFDr9fAQrg7iaJZ) | 0.71 (https://gmgn.ai/sol/address/4SGsfKU4EZT2QUSKgmHxumaEg7TPqw7Ry5N7QE6Ncu8f) | 0.6 (https://gmgn.ai/sol/address/9N115DvPaQ8JBRpNKYEqHb6zpDroMghY3XTgEY9bPYDY) | 0.6 (https://gmgn.ai/sol/address/4hAFR3vWVxsz72GbRtpSgRLgoHSTbrqBB5XtAsoSjxdW) | 0.59 (https://gmgn.ai/sol/address/DzxJZe5fJiLR2yV5x2VRWrczQFcTu5f267HFMBZk1n5k) | 0.57 (https://gmgn.ai/sol/address/Gi7nuWAcJ1EkbXGxdDiopEbT1f4nP1bcotJefWgM9wPf) | 0.57 (https://gmgn.ai/sol/address/Fx4vXtW56dHegfKjEJJnaTX5JtFg1cdzWVxuHQiZqGxM) | 0.57 (https://gmgn.ai/sol/address/2aYpTsDpE1PRAoEPGfcv9Uo66oBHkBkFLPbnQiRkFJqd) | 0.54 (https://gmgn.ai/sol/address/AxLSsHE6iXssJe6MjLbbgecpbwg2jdgHnM7umMsY3QGz) | 0.52 (https://gmgn.ai/sol/address/4xK8gtJ22sNB7JzYhF6MuckECLWaJLpNaSmUU82FPMWm)
    # 🐀 Insiders: 2.22%
    # 📕 Rug Probability: --
    # 📒 Rug history: --

    # 🎯 First 70 buyers (Snipers 6):
    # 🌑🌑🌑🌑🌑🌗🌑🌑🌑🌕
    # 🌑🌕🌑🌑🌑🌕🌕🌑🌑🌑
    # 🌗🌑🌑🌑🌕🌑🌑🌑🌕🌑

    # 🌕 Hold:                     13
    # 🌝 Bought more:       0
    # 🌗 Sold part:              3
    # 🌑 Sold out:               54

    # Total Bought: 23.99%
    # Current Total Holdings: 0.01%

    # Token
    # madHpjRn6bd8t78Rsy7NuSuNwWa2HU8ByPobZprHbHv

    # Backup BOT: US (https://t.me/US_GMGNBOT?start=madHpjRn6bd8t78Rsy7NuSuNwWa2HU8ByPobZprHbHv) | 01 (https://t.me/GMGN_sol_bot?start=madHpjRn6bd8t78Rsy7NuSuNwWa2HU8ByPobZprHbHv) | 02 (https://t.me/GMGN_sol02_bot?start=madHpjRn6bd8t78Rsy7NuSuNwWa2HU8ByPobZprHbHv) | 03 (https://t.me/GMGN_sol03_bot?start=madHpjRn6bd8t78Rsy7NuSuNwWa2HU8ByPobZprHbHv) | 04 (https://t.me/GMGN_sol04_bot?start=madHpjRn6bd8t78Rsy7NuSuNwWa2HU8ByPobZprHbHv)

    #   🐦 Twitter (https://twitter.com/madcoinvip)  |  🌏 Website (https://www.madcoin.vip/)  |  ✈️ Telegram (https://t.me/MadCoinVip)

    global obj_ready_get_token_info
    event_message = event.message
    message_text = event.message.message
 
    print("enter handle_incoming_GMGN_bot_NewMessage client_gate.on(events.NewMessage event_message=",event_message)

    if len(list(obj_ready_get_token_info.keys()))==0:
            return
            
    dalao_timestamp = min(list(obj_ready_get_token_info.keys()))
    obj_dalao_swap_info = obj_ready_get_token_info[dalao_timestamp]
    str_swap_token_address=  obj_dalao_swap_info["str_swap_token_address"]
    str_dalao_address = obj_dalao_swap_info["str_dalao_address"]
 
    now_price =     None
    last_5m_change = None
    last_1h_change = None
    number_open =   0
    number_liq =    0
    nomint_flag = None
    blacklist_flag = None
    burnt_flag = None
    number_insiders =   None
    number_holders = 0
    number_top_10_holding = 0
    is_normal = True

    arr_total_split_message = re.split('\n+', message_text)


    if "Pump Status: Trading on Raydium" in message_text:
        arr_total_split_message.pop(1)

    for idx,split_message in enumerate( arr_total_split_message):
        split_message=split_message.lower().strip()
        
        if idx ==  1 and "$" in split_message and now_price is None:
            # 获取当前价格
            temp_now_price = split_message.split(" ")[0]
            temp_now_price=temp_now_price.replace("$","")
            arr_temp_now_price = temp_now_price.split(".")
            integer_now_price  = arr_temp_now_price[0]
            fractional_now_price = arr_temp_now_price[1]
            if "{" in fractional_now_price:
                fractional_now_price = re.sub(r"[{}]", " ", fractional_now_price)
                arr_fractional_now_price  = fractional_now_price.split(" ")
                fractional_now_price =   "0" * (int(arr_fractional_now_price[-2]))+ arr_fractional_now_price[-1]
            now_price = integer_now_price + "." + fractional_now_price
            

        elif idx ==  2  and  "5m" in split_message  :
            # 获取最近时间的价格变化
            # split_message = re.sub(r"[|%:📈]", "", split_message)
            # split_message = re.sub(r"\s+", " ", split_message)

            split_message = keep_alnum_forgmgn(split_message)
            split_message = re.sub(r"\s+", " ", split_message)
            split_message=split_message.strip()
        
            arr_price_change = split_message.split(" ")
            if len(arr_price_change)==6:
                last_5m_change = float(arr_price_change[3])
                last_1h_change  =   float(arr_price_change[5])

        elif idx == 4 and  "liq" in split_message:
            split_message=split_message.replace(",","")
            split_message = keep_alnum_forgmgn(split_message)
            split_message=split_message.strip()
            split_message =  re.sub(r"\s+", " ", split_message)
            arr_split_message = split_message.split(' ')
            number_liq = float(arr_split_message[1])
            
        elif idx == 6 and "holders" in split_message:
            split_message = keep_alnum_forgmgn(split_message)
            split_message=split_message.strip()
            split_message =  re.sub(r"\s+", " ", split_message)
            arr_split_message = split_message.split(' ')
            number_holders = arr_split_message[1]
        
        elif  idx == 9 and"open" in split_message:
            split_message = keep_alnum_forgmgn(split_message)
            split_message=split_message.strip()
            split_message =  re.sub(r"\s+", " ", split_message)
            arr_split_message = split_message.split(' ')
            if "d" in arr_split_message[1]:
                number_open = int(arr_split_message[1].replace("d",""))  *24      
            elif "h" in  arr_split_message[1]:
                number_open = int(arr_split_message[1].replace("h",""))          
        elif  idx == 12 and"audit" in split_message:

            split_message =split_message.replace("✅","yes")
            split_message =split_message.replace("❌","no")
            split_message = keep_alnum_forgmgn(split_message)
            split_message=split_message.strip()
            split_message =  re.sub(r"\s+", " ", split_message)
            arr_split_message = split_message.split(' ')

            nomint_flag = arr_split_message[2]
            blacklist_flag   = arr_split_message[4]
            burnt_flag = arr_split_message[6]

        elif  idx == 13 and  "top 10 holdings" in split_message:
            split_message = keep_alnum_forgmgn(split_message)
            split_message=split_message.strip()
            split_message =  re.sub(r"\s+", " ", split_message)
            arr_split_message = split_message.split(' ')
            number_top_10_holding =  float(arr_split_message[3])
    
        
        elif idx == 15 and  "insiders" in split_message:
            split_message = keep_alnum_forgmgn(split_message)
            split_message=split_message.replace("--","0")
            split_message=split_message.strip()
            split_message =  re.sub(r"\s+", " ", split_message)
            arr_split_message = split_message.split(' ')
            number_insiders =  float(arr_split_message[1])

        if (nomint_flag and  blacklist_flag  and burnt_flag ) == False:
            is_normal = False
        if number_liq <= 150:
            # 1 sol = 150 $
            #  700sol = 100k $
            is_normal =False
        if number_open <= 24:
            is_normal =False
        if number_holders <= 400:
            is_normal =False
        if number_top_10_holding  >= 35:
            is_normal =False

        try:
            obj_token_info[str_swap_token_address]["is_normal"] = is_normal
            obj_token_info[str_swap_token_address]["now_price"] = now_price
            obj_token_info[str_swap_token_address]["number_open"] = number_open
            obj_token_info[str_swap_token_address]["number_liq"] = number_liq
            obj_token_info[str_swap_token_address]["number_top_10_holding"] = number_top_10_holding
            obj_token_info[str_swap_token_address]["last_5m_change"] = last_5m_change
            obj_token_info[str_swap_token_address]["last_1h_change"] = last_1h_change
        except Exception as e:
              
             print(f"handle_incoming_GMGN_bot_NewMessage obj_token_info[str_swap_token_address] str_swap_token_address={str_swap_token_address}",obj_token_info[str_swap_token_address])
             raise
        if is_normal ==False:
            print(f"{str_swap_token_address} is unnormal")
            obj_ready_get_token_info[dalao_timestamp]["need_remove"] = True
            del obj_ready_get_token_info[dalao_timestamp]
        
            return

        if obj_last_3h_token_info.get(str_swap_token_address) is None:
            obj_last_3h_token_info[str_swap_token_address]={}
        if obj_last_3h_token_info.get(str_swap_token_address).get(str_dalao_address) is None:
            obj_last_3h_token_info[str_swap_token_address][str_dalao_address]={}
        obj_last_3h_token_info[str_swap_token_address][str_dalao_address]["dalao_timestamp"]=dalao_timestamp
        temp_arr_last_3h_token_dalao = list(obj_last_3h_token_info.keys())

        # 去除 过期的 dalao
        for dalao_address in temp_arr_last_3h_token_dalao:
            cur_dalao_timestamp =  obj_last_3h_token_info[str_swap_token_address][dalao_address]["dalao_timestamp"]
            if dalao_timestamp - cur_dalao_timestamp>=3*3600*1000:
                del obj_last_3h_token_info[str_swap_token_address][dalao_address]
                
        send_token_info_to_feishu(token_info= {
        "str_swap_token_address":str_swap_token_address,
        "now_price":now_price,
        "number_open":number_open,
        "number_liq":number_liq,
        "number_holders":number_holders,
        "number_top_10_holding":number_top_10_holding,
        "last_5m_change":last_5m_change,
        "last_1h_change":last_1h_change,
        "arr_dalao_address":list(obj_last_3h_token_info[str_swap_token_address].keys())

        })
 
        obj_ready_get_token_info[dalao_timestamp]["need_remove"] = True
        del obj_ready_get_token_info[dalao_timestamp]


        return



# @client_gate.on(events.MessageEdited(chats=[ GMGN_bot_id ], incoming=True))
# async def handle_incoming_GMGN_bot_MessageEdited(event):

#     event_message = event.message
#     message_text = event.message.message
#     print(
#         "handle_incoming_GMGN_bot_MessageEdited @client_gate.on(events.MessageEdited event_message=",event_message)
 

obj_global_info ={
    "timedTasks_idx":0
}

sys.excepthook = global_exception_hook
signal.signal(signal.SIGTERM, term_sig_handler)
signal.signal(signal.SIGINT, term_sig_handler)
print(f"Listening for messages containing  in chats ichat names...")
 


  
 
 
async def timedTasks():
    global obj_global_info
    obj_global_info["timedTasks_idx"]+=1
    cur_timedTasks_idx =obj_global_info["timedTasks_idx"] 
    if cur_timedTasks_idx <8:
        return
     
    if cur_timedTasks_idx%900 == 0:
        obj_global_info["timedTasks_idx"]=10

        # save_obj_pendingSellToken()
        # save_obj_unraydium_token()
        # save_obj_firsellToken()
        # save_obj_dalaobuytokenscounts()
        
        # fortest_save_tempobj_mine_ready_swap_action()
         
    await handle_dalao_swap()
    return



 
# scheduler = BackgroundScheduler({'apscheduler.timezone': 'UTC'})
scheduler = AsyncIOScheduler({'apscheduler.timezone': 'UTC'})
scheduler.add_job(timedTasks, "interval", seconds=1)   
# scheduler.add_job(func=timedTasks, trigger="cron", seconds=10)   
# '*/1 * * * * *'

scheduler.start()
client_gate.run_until_disconnected()
asyncio.get_event_loop().run_forever()
# client_bill.run_until_disconnected()
