import time
import asyncio
from telethon import TelegramClient, events
from telethon.errors.rpcerrorlist import AuthKeyError
from telethon.sync import TelegramClient as SyncTelegramClient
import json
import datetime
import signal
import sys
import math
import requests
from telethon.tl.types import MessageEntityTextUrl
from apscheduler.schedulers.background import BackgroundScheduler
from telethon.tl.types import PeerUser, PeerChat, PeerChannel
import os
import traceback
import re
from apscheduler.schedulers.asyncio import AsyncIOScheduler

old_print = print


def timestamped_print(*args, **kwargs):
    old_print(datetime.datetime.utcnow().replace(
        microsecond=0), *args, **kwargs)


print = timestamped_print
print('\n'*5)

def global_exception_hook(exc_type, exc_value, exc_traceback):
    print(f"Global exception: {exc_type.__name__} - {exc_value}")
    traceback.print_tb(exc_traceback)
    raise

def keep_alnum_forgmgn(string):
    return re.sub(r'[^a-zA-Z0-9\.\s\+\-]', ' ', string)


def keep_alnum(string):
    return re.sub(r'[^a-zA-Z0-9\.\s:+-]', ' ', string)
 
def term_sig_handler(signum, frame):   
    # save_obj_unraydium_token()
    print(f'catched singal: {signum}')
    
    sys.exit()




def global_exception_hook(exc_type, exc_value, exc_traceback):
    print(f"Global exception: {exc_type.__name__} - {exc_value}")
    traceback.print_tb(exc_traceback)
    raise



api_id_gate = 29760088
api_hash_gate = "7cd2222e0629c770789f9c6cf280d051"

# ID: 6541198030,  Name: Fluxbot
api_id_bill = 26338039
api_hash_bill = "09bcd8c34c696df21466303aa13c8913"

Fluxbot_id = 6541198030
GMGN_bot_id = 6344329830
AveSniperBot_id = 6986192261
 

Sol_Trading_Bot_Europe_id = 7000042208
Sol_Trading_Bot_Americas_id = 7174198482
Sol_Trading_Bot_id = 6899553164
Sol_Trading_Bot_New_id=6556421217
arr_Sol_Trading_Bot_id = [Sol_Trading_Bot_Europe_id , Sol_Trading_Bot_Americas_id ,Sol_Trading_Bot_id,Sol_Trading_Bot_New_id ]
now_sol_trading_bot_id = arr_Sol_Trading_Bot_id[0]
now_sol_trading_bot_id_idx = 0
lastest_message_id = -1

feishu_url = 'https://open.feishu.cn/open-apis/bot/v2/hook/a68cffbf-9104-427b-8e25-62dfaf363a47'
utc_plus_8 = datetime.timezone(datetime.timedelta(hours=8))

 
client_gate = TelegramClient('anon_gate', api_id_gate, api_hash_gate)
client_gate.start()



obj_queueing_pairaddress={}

obj_token_info={

}

 
 
async def  send_tokenaddress_message(GMGN_id , str_tokenaddress):  
    print(f"enter send_token_address_message str_tokenaddress={str_tokenaddress}")      
    
    await client_gate.send_message(GMGN_id, str_tokenaddress)
    return

async def  send_pairaddress_message(Sol_Trading_Bot_id , str_pairaddress):  
    print(f"enter send_pairaddress_message str_pairaddress={str_pairaddress}")      
    
    await client_gate.send_message(Sol_Trading_Bot_id, str_pairaddress)
    return

# flux 获取dlao swap info 保存进 obj_queueing_pairaddress 
# 在一个定时器 的函数中 便利读取 obj_queueing_pairaddress ，对每一个元素进行check 如果可以买卖则进行买卖


def send_token_info_to_feishu(token_info):
    print("send_token_info_to_feishu token_info=",token_info)
    return
 

import pathlib
import shutil

 

set_has_read_file=set()

obj_receive_pair={

    # "pair":{
    #     "str_tokenaddress":"",
  
    #     "timestamp":0,
       
    # }
}
import  pandas as pd
 
is_handleing_pairaddress_file = False
async def handle_pairaddress_file():
        
        global set_has_read_file,is_handleing_pairaddress_file ,obj_receive_pair ,obj_queueing_pairaddress

        if is_handleing_pairaddress_file==True:
            return
        is_handleing_pairaddress_file = True
        
        arr_csv_file = [f for f in os.listdir(
            "/root/Downloads/") if f.endswith(".csv")]
        cur_now_timestamp = int(time.time()*1000)

        for csv_file in arr_csv_file:
            csv_file_timestamp = int(csv_file.replace(".csv",""))
            # 2分钟以前的文件直接删除
            if cur_now_timestamp  - csv_file_timestamp >= 2 * 60 * 1000:
                # os.path.exists(f"/root/Downloads/{csv_file}"):
                os.remove(f"/root/Downloads/{csv_file}")
        #重新获取当前csv文本 
        arr_csv_file = [f for f in os.listdir(
            "/root/Downloads/") if f.endswith(".csv")]
        set_cur_file = set(arr_csv_file)
        
        arr_cur_no_read_file =list (set_cur_file - set_has_read_file)
        if len(arr_cur_no_read_file)==0:
            return
        df = None
        for csv_file in arr_cur_no_read_file:
            cur_df = pd.read_csv(f"/root/Downloads/{csv_file}",dtype=object)
            df =pd.concat([df,cur_df])
        arr_pairaddress = df["pairaddress"].dropna().tolist()
        # for pairaddress in arr_pairaddress:
        for idx,str_pairaddress in enumerate(arr_pairaddress):
            if obj_receive_pair.get(str_pairaddress) is None:
                obj_receive_pair[str_pairaddress]={
                         "str_tokenaddress":"",
                        "timestamp":cur_now_timestamp
                }
                obj_receive_pair[str_pairaddress]["timestamp"] =cur_now_timestamp
                cur_key = cur_now_timestamp
                while True:
                    cur_key = cur_key - (idx+2)*2
                    if obj_queueing_pairaddress.get(cur_key) is None:
                        obj_queueing_pairaddress[cur_key] = {
                                                            "str_pairaddress":str_pairaddress,
                                                            "is_sending":False,
                                                            "sending_time":0,
                                                            "send_counts":0,
                                                            "pair_timestamp" :cur_key,
                                                            }
                        break
                    else:
                        continue
            elif  obj_receive_pair.get(str_pairaddress)["str_tokenaddress"] != "" and cur_now_timestamp -  obj_receive_pair.get(str_pairaddress)["timestamp"] >= 9 * 60* 1000:
                # 离上次处理过了 9分钟 再处理 重新获取此pair 信息  
                # 为什么为9 因为 油猴脚本是10分钟重新获取已存在的pair ，为了可以在油猴脚本处理后在处理pair ，要先处理当前py的记录
                obj_receive_pair[str_pairaddress]["timestamp"] =cur_now_timestamp
                cur_key = cur_now_timestamp
                while True:
                    cur_key = cur_key + (idx+2)*2 + 10*1000
                    if obj_queueing_tokenaddress.get(cur_key) is None:
                        obj_queueing_tokenaddress[cur_key] = {
                                    "str_tokenaddress": obj_pair_2_tokenaddress[  str_pairaddress] ,
                                    "is_sending":False,
                                    "sending_time":0,
                                    "send_counts":0,
                                    "token_timestamp" :cur_key,
                                                            }
                        break
                    else:
                        continue
                continue
            else:
                continue



        set_has_read_file = set(arr_csv_file)
        is_handleing_pairaddress_file = False
        return


async def handle_obj_queueing_tokenaddress(obj_one_queueing_tokenaddress):

    global obj_queueing_tokenaddress

    cur_now_timestamp = int(time.time()*1000)
    str_tokenaddress = obj_one_queueing_tokenaddress["str_tokenaddress"]
    token_timestamp =  obj_one_queueing_tokenaddress["token_timestamp"]


    
    if obj_one_queueing_tokenaddress["is_sending"] == True:
        if cur_now_timestamp - obj_one_queueing_tokenaddress["sending_time"] >=obj_one_queueing_tokenaddress["send_counts"]* 40*1000:
            print(f"token_timestamp={token_timestamp}   str_tokenaddress={str_tokenaddress} is_sending_too_long del")
            del obj_queueing_tokenaddress[token_timestamp] 
        else:
            print(f"token_timestamp={token_timestamp}    str_tokenaddress={str_tokenaddress} is_sending")
        return True
    obj_one_queueing_tokenaddress["sending_time"]  = cur_now_timestamp
    
    obj_one_queueing_tokenaddress["send_counts"]+=1
    obj_one_queueing_tokenaddress["is_sending"] = True
    await send_tokenaddress_message(GMGN_id=GMGN_bot_id  , str_tokenaddress=str_tokenaddress)

    return True
        
        
        
async def handle_obj_queueing_pairaddress(obj_one_queueing_pairaddress     ):
    global obj_queueing_pairaddress

    cur_now_timestamp = int(time.time()*1000)
    str_pairaddress = obj_one_queueing_pairaddress["str_pairaddress"]
    pair_timestamp =  obj_one_queueing_pairaddress["pair_timestamp"]


    
    if obj_one_queueing_pairaddress["is_sending"] == True:
        if cur_now_timestamp - obj_one_queueing_pairaddress["sending_time"] >=obj_one_queueing_pairaddress["send_counts"]* 40*1000:
            print(f"pair_timestamp={pair_timestamp}   str_pairaddress={str_pairaddress} is_sending_too_long del")
            del obj_queueing_pairaddress[pair_timestamp] 
        else:
            print(f"pair_timestamp={pair_timestamp}    str_pairaddress={str_pairaddress} is_sending")
        return True
    obj_one_queueing_pairaddress["sending_time"]  = cur_now_timestamp
    obj_one_queueing_pairaddress["send_counts"]+=1
    obj_one_queueing_pairaddress["is_sending"] = True
    await send_pairaddress_message(Sol_Trading_Bot_id=now_sol_trading_bot_id,str_pairaddress=str_pairaddress)

    return True

obj_queueing_send_feishu={
# "feishu_timestamp":{
#         "is_sending":False,
# "str_tokenaddress":str_tokenaddress,
# "now_price":now_price,
# "number_open":number_open,
# "number_liq":number_liq,
# "number_holders":number_holders,
# "number_top_10_holding":number_top_10_holding,
# "last_5m_change":last_5m_change,
# "last_1h_change":last_1h_change,
# "feishu_timestamp":cur_now_timestamp,
# }
}
 

async def ready_send_feishu(obj_one_queueing_send_feishu):
    global obj_queueing_send_feishu , utc_plus_8
       

    cur_now_timestamp = int(time.time()*1000)
    str_tokenaddress = obj_one_queueing_send_feishu["str_tokenaddress"]
    feishu_timestamp =  obj_one_queueing_send_feishu["feishu_timestamp"]


    if obj_one_queueing_send_feishu["is_sending"] == True:
        if cur_now_timestamp - obj_one_queueing_send_feishu["sending_time"] >=obj_one_queueing_send_feishu["send_counts"]* 40*1000:
            print(f"feishu_timestamp={feishu_timestamp}   str_tokenaddress={str_tokenaddress} is_sending_too_long del")
            del obj_queueing_send_feishu[feishu_timestamp] 
        else:
            print(f"feishu_timestamp={feishu_timestamp}    str_tokenaddress={str_tokenaddress} is_sending")
        return True
    
    
    obj_one_queueing_send_feishu["sending_time"]  = cur_now_timestamp
    obj_one_queueing_send_feishu["send_counts"]+=1
    obj_one_queueing_send_feishu["is_sending"] = True


    # 将时间戳转换为datetime对象，并指定时区 ,转换为ISO 8601格式的时间字符串，包含时区信息

    
    str_iso8601_date    = datetime.datetime.fromtimestamp(feishu_timestamp/1000, tz=utc_plus_8).isoformat()
    str_now_price =  str(obj_one_queueing_send_feishu["now_price"])
    str_last_5m_change =  str(obj_one_queueing_send_feishu["last_5m_change"])
    str_last_1h_change =  str(obj_one_queueing_send_feishu["last_1h_change"])
    str_number_holders = str(obj_one_queueing_send_feishu["number_holders"])

    send_feishu({
        "str_iso8601_date":  str_iso8601_date,
        "str_tokenaddress":str_tokenaddress,
        "str_number_holders":str_number_holders,
        "str_last_5m_change":str_last_5m_change,
        "str_last_1h_change":str_last_1h_change,
        "str_now_price": str_now_price
    })

    # 发给飞书
    del obj_queueing_pairaddress[feishu_timestamp]  

    return



def send_feishu(obj_sendmsg):
    payload_message = {
        "msg_type": "post",
        "content": {
            "post": {
                "zh_cn": {
                    "title": obj_sendmsg["str_tokenaddress"],
                    "content": [
                        
                    ]
                }
            }
        }
    }

    headers = {
        "Content-Type": "application/json; charset=utf-8",
    }
    content = []

 
    content.append([{
        "tag": "text",
        'text':  obj_sendmsg['str_iso8601_date']
    } 
    ])

    content.append([
        {
        "tag": "text",
        'text': "price: " +  obj_sendmsg['str_now_price']  
        },
        {
        "tag": "text",
        'text': '   '
        } ,
        {
        "tag": "text",
        'text': 'holder: ' + obj_sendmsg["str_number_holders"]  
        }
    
    ])

    content.append([
        {
        "tag": "text",
        'text':  "5m: " + obj_sendmsg['str_last_5m_change'] + "%"
        },
        {
        "tag": "text",
        'text': '   '
        } ,
        {
        "tag": "text",
        'text': '1h: ' + obj_sendmsg["str_last_1h_change"] + "%"
        }
    
    ])

    content.append([{
        "tag": "text",
        "text": "---------------"
    }])
    content.append([{
        "tag": "a",
        "href": "https://gmgn.ai/sol/token/" + obj_sendmsg["str_tokenaddress"],
        "text": "GMGN  " + obj_sendmsg["str_tokenaddress"]
    }])


    content.append([{
        "tag": "at",
        "user_id": "all",
        "user_name": "allman"
    }])

    payload_message["content"]["post"]["zh_cn"]["content"] = content
    payload_message["content"] = json.dumps(payload_message["content"])

    payload_message = json.dumps(payload_message)
    response = requests.post(
        url=feishu_url, headers=headers, data=payload_message)
    response_json = response.json()
    return 
     



async def ready_send_feishu_timed():
    global obj_queueing_send_feishu

    if len(obj_queueing_send_feishu.keys())==0:
        return
    feishu_timestamp = min(list(obj_queueing_send_feishu.keys()))
    obj_one_queueing_send_feishu = obj_queueing_send_feishu[feishu_timestamp]

    handle_res = await ready_send_feishu(obj_one_queueing_send_feishu=obj_one_queueing_send_feishu )
 
 
    return


async def handle_obj_queueing_pairaddress_timed():

    global obj_queueing_pairaddress
    while True:
        if len(obj_queueing_pairaddress.keys())==0:
            break
        pair_timestamp = min(list(obj_queueing_pairaddress.keys()))
        obj_one_queueing_pairaddress = obj_queueing_pairaddress[pair_timestamp]
 
        handle_res = await handle_obj_queueing_pairaddress(obj_one_queueing_pairaddress=obj_one_queueing_pairaddress )
        if handle_res == True:
            break
        else :
            continue

    return



async def handle_obj_queueing_tokenaddress_timed():

    global obj_queueing_tokenaddress
    while True:
        if len(obj_queueing_tokenaddress.keys())==0:
            break
        token_timestamp = min(list(obj_queueing_tokenaddress.keys()))
        obj_one_queueing_tokenaddress = obj_queueing_tokenaddress[token_timestamp]
 
        handle_res = await handle_obj_queueing_tokenaddress(obj_one_queueing_tokenaddress=obj_one_queueing_tokenaddress )
        if handle_res == True:
            break
        else :
            continue

    return

obj_pair_2_tokenaddress={

}
@client_gate.on(events.NewMessage(chats=[Sol_Trading_Bot_Europe_id, Sol_Trading_Bot_Americas_id,Sol_Trading_Bot_id,Sol_Trading_Bot_New_id], incoming=True))
async def handle_incoming_gate_Sol_Trading_Bot_Europe_NewMessage(event):
    
    global now_sol_trading_bot_id ,now_sol_trading_bot_id_idx,lastest_message_id ,obj_queueing_tokenaddress

    event_message = event.message
    message_text = event.message.message

    
  
    user_id=event_message.chat_id
    lastest_message_id = event.id
    print(f"lastest_message_id={lastest_message_id}")
    print("enter handle_incoming_gate_Sol_Trading_Bot_Europe_NewMessage client_gate.on(events.NewMessage message_text=",message_text)
    pair_timestamp = min(list(obj_queueing_pairaddress.keys()))
    obj_one_queueing_pairaddress = obj_queueing_pairaddress[pair_timestamp]
    str_pairaddress = obj_one_queueing_pairaddress["str_pairaddress"]
 
    if "made requests too often" in message_text.lower():
        # 这个机器人暂时不能用  用其他的机器人
        print(f"user_id= {user_id} too often")
        now_sol_trading_bot_id_idx = (now_sol_trading_bot_id_idx+1)%len(arr_Sol_Trading_Bot_id)
        now_sol_trading_bot_id = arr_Sol_Trading_Bot_id[now_sol_trading_bot_id_idx]
        obj_one_queueing_pairaddress["send_counts"] -=1
        # obj_one_queueing_pairaddress["send_time"] = int(time.time()*1000)
        await send_pairaddress_message(Sol_Trading_Bot_id=now_sol_trading_bot_id ,str_pairaddress=str_pairaddress )
        return
    
    if  "CA:" not in message_text:
        # 不能要 pass 
        del obj_queueing_pairaddress[pair_timestamp]
        return
    
 
    message_text = message_text.replace('✅' , 'yes')  
    message_text = message_text.replace('❌' , 'no')  
    message_text=keep_alnum(message_text)
    arr_message_text = message_text.split("\n")
    str_tokenaddress = None
    for split_message_text in arr_message_text:
        if  "CA:"  in split_message_text:
            split_message_text=split_message_text.replace("CA:","")
            str_tokenaddress=split_message_text.strip()
            break


    obj_receive_pair[str_pairaddress]["str_tokenaddress"]=str_tokenaddress

    message_text = message_text.lower()
    if "freeze revoked: no" in message_text or "Renounced: no" in message_text:
        # 不能要 pass 
        del obj_queueing_pairaddress[pair_timestamp]
        return
    cur_now_timestamp = int(time.time()*1000)
    obj_queueing_tokenaddress[cur_now_timestamp]={
            "str_tokenaddress":str_tokenaddress,
            "is_sending":False,
            "sending_time":0,
            "send_counts":0,
            "token_timestamp" :cur_now_timestamp,
    }


    del obj_queueing_pairaddress[pair_timestamp]
    return

 
 
obj_queueing_tokenaddress={

}
 

 
@client_gate.on(events.NewMessage(chats=[GMGN_bot_id ], incoming=True))
async def handle_incoming_GMGN_bot_NewMessage(event):
    # 【Solana】MAD (MAD)

    # $0.0{4}16505   🔴 -2.26%  Price Chart (https://gmgn.ai/sol/token/madHpjRn6bd8t78Rsy7NuSuNwWa2HU8ByPobZprHbHv?utm_source=telegram&utm_campaign=tg_cmdbot_hot) | Snipe with Bot (https://t.me/GMGN_sol_bot?start=madHpjRn6bd8t78Rsy7NuSuNwWa2HU8ByPobZprHbHv)
    # 📈 5m | 1h | 6h: -0.25% | 0.76% | -3.7%
    # 💰 MC: $16.5M
    # 💧 Liq: 1,862.71 SOL ($512K 🔥99.98%)
    # 💰 Initial LP: 15 SOL (100% supply)
    # 👥 Holders: 12326
    # 👨‍🍳 Creator:  CNBx....FmP (https://solscan.io/account/CNBxpRqrzZZenHU4jT9XXpcxPChtDafTnnrUfSyYFmP8) (2.0708 SOL)
    # 🔥 DEV Burnt: --
    # 🕒 Open: 43d  ago
    # 🔥 Smart Buy/Sell: -/-
    # 🦅 DEXScreener: Advertised ❌ / Update Social ❌

    # 🔔 Audit: NoMint ✅ / Blacklist ✅ / Burnt ✅
    # 👥 Top 10 holdings: 6.92%<30% ✅
    # 1.65 (https://gmgn.ai/sol/address/ASTyfSima4LLAdDgoFGkgqoKowG1LZFDr9fAQrg7iaJZ) | 0.71 (https://gmgn.ai/sol/address/4SGsfKU4EZT2QUSKgmHxumaEg7TPqw7Ry5N7QE6Ncu8f) | 0.6 (https://gmgn.ai/sol/address/9N115DvPaQ8JBRpNKYEqHb6zpDroMghY3XTgEY9bPYDY) | 0.6 (https://gmgn.ai/sol/address/4hAFR3vWVxsz72GbRtpSgRLgoHSTbrqBB5XtAsoSjxdW) | 0.59 (https://gmgn.ai/sol/address/DzxJZe5fJiLR2yV5x2VRWrczQFcTu5f267HFMBZk1n5k) | 0.57 (https://gmgn.ai/sol/address/Gi7nuWAcJ1EkbXGxdDiopEbT1f4nP1bcotJefWgM9wPf) | 0.57 (https://gmgn.ai/sol/address/Fx4vXtW56dHegfKjEJJnaTX5JtFg1cdzWVxuHQiZqGxM) | 0.57 (https://gmgn.ai/sol/address/2aYpTsDpE1PRAoEPGfcv9Uo66oBHkBkFLPbnQiRkFJqd) | 0.54 (https://gmgn.ai/sol/address/AxLSsHE6iXssJe6MjLbbgecpbwg2jdgHnM7umMsY3QGz) | 0.52 (https://gmgn.ai/sol/address/4xK8gtJ22sNB7JzYhF6MuckECLWaJLpNaSmUU82FPMWm)
    # 🐀 Insiders: 2.22%
    # 📕 Rug Probability: --
    # 📒 Rug history: --

    # 🎯 First 70 buyers (Snipers 6):
    # 🌑🌑🌑🌑🌑🌗🌑🌑🌑🌕
    # 🌑🌕🌑🌑🌑🌕🌕🌑🌑🌑
    # 🌗🌑🌑🌑🌕🌑🌑🌑🌕🌑

    # 🌕 Hold:                     13
    # 🌝 Bought more:       0
    # 🌗 Sold part:              3
    # 🌑 Sold out:               54

    # Total Bought: 23.99%
    # Current Total Holdings: 0.01%

    # Token
    # madHpjRn6bd8t78Rsy7NuSuNwWa2HU8ByPobZprHbHv

    # Backup BOT: US (https://t.me/US_GMGNBOT?start=madHpjRn6bd8t78Rsy7NuSuNwWa2HU8ByPobZprHbHv) | 01 (https://t.me/GMGN_sol_bot?start=madHpjRn6bd8t78Rsy7NuSuNwWa2HU8ByPobZprHbHv) | 02 (https://t.me/GMGN_sol02_bot?start=madHpjRn6bd8t78Rsy7NuSuNwWa2HU8ByPobZprHbHv) | 03 (https://t.me/GMGN_sol03_bot?start=madHpjRn6bd8t78Rsy7NuSuNwWa2HU8ByPobZprHbHv) | 04 (https://t.me/GMGN_sol04_bot?start=madHpjRn6bd8t78Rsy7NuSuNwWa2HU8ByPobZprHbHv)

    #   🐦 Twitter (https://twitter.com/madcoinvip)  |  🌏 Website (https://www.madcoin.vip/)  |  ✈️ Telegram (https://t.me/MadCoinVip)

    global obj_queueing_tokenaddress
    event_message = event.message
    message_text = event.message.message
 
    print("enter handle_incoming_GMGN_bot_NewMessage client_gate.on(events.NewMessage message_text=",message_text)

    if len(list(obj_queueing_tokenaddress.keys()))==0:
            return
            
    token_timestamp = min(list(obj_queueing_tokenaddress.keys()))
    obj_one_queueing_tokenaddress = obj_queueing_tokenaddress[token_timestamp]
    str_tokenaddress=  obj_one_queueing_tokenaddress["str_tokenaddress"]
 
 
    now_price =     None
    last_5m_change = None
    last_1h_change = None
    number_open =   0
    number_liq =    0
    nomint_flag = None
    blacklist_flag = None
    burnt_flag = None
    number_insiders =   None
    number_holders = 0
    number_top_10_holding = 0
    is_normal = True

    arr_total_split_message = re.split('\n+', message_text)


    if "Pump Status: Trading on Raydium" in message_text:
        arr_total_split_message.pop(1)

    for idx,split_message in enumerate( arr_total_split_message):
        split_message=split_message.lower().strip()
        print(  "split_message=",idx,split_message)
        
        if    "$" in split_message and now_price is None:
            # 获取当前价格
            temp_now_price = split_message.split(" ")[0]
            temp_now_price=temp_now_price.replace("$","")
            arr_temp_now_price = temp_now_price.split(".")
            integer_now_price  = arr_temp_now_price[0]
            fractional_now_price = arr_temp_now_price[1]
            if "{" in fractional_now_price:
                fractional_now_price = re.sub(r"[{}]", " ", fractional_now_price)
                arr_fractional_now_price  = fractional_now_price.split(" ")
                fractional_now_price =   "0" * (int(arr_fractional_now_price[-2]))+ arr_fractional_now_price[-1]
            now_price = integer_now_price + "." + fractional_now_price
            

        elif   "5m" in split_message  :
            # 获取最近时间的价格变化
            # split_message = re.sub(r"[|%:📈]", "", split_message)
            # split_message = re.sub(r"\s+", " ", split_message)

            split_message = keep_alnum_forgmgn(split_message)
            split_message = re.sub(r"\s+", " ", split_message)
            split_message=split_message.strip()
        
            arr_price_change = split_message.split(" ")
            if len(arr_price_change)==6:
                last_5m_change = float(arr_price_change[3])
                last_1h_change  =   float(arr_price_change[5])

        elif   "liq" in split_message:
            split_message=split_message.replace(",","")
            split_message = keep_alnum_forgmgn(split_message)
            split_message=split_message.strip()
            split_message =  re.sub(r"\s+", " ", split_message)
            arr_split_message = split_message.split(' ')
            number_liq = float(arr_split_message[1])
            
        elif  "holders" in split_message:
            split_message = keep_alnum_forgmgn(split_message)
            split_message=split_message.strip()
            split_message =  re.sub(r"\s+", " ", split_message)
            arr_split_message = split_message.split(' ')
            number_holders = arr_split_message[1]
        
        elif  "open" in split_message:
            split_message = keep_alnum_forgmgn(split_message)
            split_message=split_message.strip()
            split_message =  re.sub(r"\s+", " ", split_message)
            arr_split_message = split_message.split(' ')
            if "d" in arr_split_message[1]:
                number_open = int(arr_split_message[1].replace("d",""))  *24      
            elif "h" in  arr_split_message[1]:
                number_open = int(arr_split_message[1].replace("h",""))          
        elif  "audit" in split_message:

            split_message =split_message.replace("✅","yes")
            split_message =split_message.replace("❌","no")
            split_message = keep_alnum_forgmgn(split_message)
            split_message=split_message.strip()
            split_message =  re.sub(r"\s+", " ", split_message)
            arr_split_message = split_message.split(' ')

            nomint_flag = arr_split_message[2]
            blacklist_flag   = arr_split_message[4]
            burnt_flag = arr_split_message[6]

        elif    "top 10 holdings" in split_message:
            split_message = keep_alnum_forgmgn(split_message)
            split_message=split_message.replace("--","0")
            split_message=split_message.strip()
            split_message =  re.sub(r"\s+", " ", split_message)
            arr_split_message = split_message.split(' ')
            number_top_10_holding =  float(arr_split_message[3])
    
        elif   "insiders" in split_message:
            split_message = keep_alnum_forgmgn(split_message)
            split_message=split_message.replace("--","0")
            split_message=split_message.strip()
            split_message =  re.sub(r"\s+", " ", split_message)
            arr_split_message = split_message.split(' ')
            number_insiders =  float(arr_split_message[1])
        
        

obj_global_info ={
    "timedTasks_idx":0
}

sys.excepthook = global_exception_hook
signal.signal(signal.SIGTERM, term_sig_handler)
signal.signal(signal.SIGINT, term_sig_handler)
print(f"Listening for messages containing  in chats ichat names...")
 


  
 
 
async def timedTasks():
    global obj_global_info
    obj_global_info["timedTasks_idx"]+=1
    cur_timedTasks_idx =obj_global_info["timedTasks_idx"] 
    if cur_timedTasks_idx <8:
        return
     
    if cur_timedTasks_idx%900 == 0:
        obj_global_info["timedTasks_idx"]=10

        
         
    await handle_pairaddress_file()
    if cur_timedTasks_idx%2 == 0:
        await handle_obj_queueing_pairaddress_timed()
    else:
        await handle_obj_queueing_tokenaddress_timed()
    await ready_send_feishu_timed()
    return



 
# scheduler = BackgroundScheduler({'apscheduler.timezone': 'UTC'})
scheduler = AsyncIOScheduler({'apscheduler.timezone': 'UTC'})
scheduler.add_job(timedTasks, "interval", seconds=1)   
# scheduler.add_job(func=timedTasks, trigger="cron", seconds=10)   
# '*/1 * * * * *'

scheduler.start()
client_gate.run_until_disconnected()
asyncio.get_event_loop().run_forever()
# client_bill.run_until_disconnected()
